#include <math.h>
#include "p12o.h"

void p1oLP_init(p1o *p, double fs, double fc)
{
    double wac = tan(M_PI * fc / fs);
    p->a1 = (wac - 1) / (wac + 1);
    p->b0 = p->b1 = wac / (wac + 1);
    p->z0 = p->z1 = 0.0;
}

double p1oLPF(p1o *p, double in)
{
    p->z0 = in - p->a1 * p->z1;
    double r = p->b0 * p->z0 + p->b1 * p->z1;
    p->z1 = p->z0;
    return r;
}

void p2oLP_init(p2o *p, double fs, double fc, double Q)
{
    double wac = tan(M_PI * fc / fs);
    double wac2 = pow(wac, 2);
    p->a1 = 2*Q*(wac - 1)*(wac + 1) / (Q*wac2 + wac + Q);
    p->a2 = (Q*wac2 - wac + Q) / (Q*wac2 + wac + Q);
    p->b0 = Q*wac2 / (Q*wac2 + wac + Q);
    p->b1 = 2*Q*wac2 / (Q*wac2 + wac + Q);
    p->b2 = Q*wac2 / (Q*wac2 + wac + Q);
    p->z0 = p->z1 = p->z2 = 0.0;
}

double p2oLPF(p2o *p, double in)
{
    p->z0 = in - p->a1 * p->z1 - p->a2 * p->z2;
    double r = p->b0 * p->z0 + p->b1 * p->z1 + p->b2 * p->z2;
    p->z2 = p->z1;
    p->z1 = p->z0;
    return r;
}
